Redmine - Patch #26714

pluck instead of map in issue_query
2017-08-17 08:30 - jwjw yy

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version:

Description
The previous issue_query.rb, line 438 version_ids = versions(:conditions => [where]).map(&:id) will issue query as:

SELECT “versions . id" AS t0_r0, “versions . project_id® AS tO_rl, ‘“versions . name  AS t0O_r2,
‘versions® . description® AS t0_r3, “versions . effective_date’ AS t0O_r4, “versions . created_on’
AS t0_r5, ‘versions . updated_on® AS tO_r6, “versions . wiki_page_title’ AS tO_r7, “versions .

‘status® AS t0_r8, “versions' . sharing’ AS t0_r9, “projects . id’ AS tl_r0, “projects . name’ AS
tl_rl, “projects’ . description’ AS tl_r2, ‘projects’ . homepage  AS tl_r3, “projects . is_public’
AS tl_r4, “projects . parent_id® AS tl_r5, “projects’ . created_on’ AS tl_r6, ‘projects’ .
‘updated_on® AS tl_r7, ‘projects’ . identifier® AS tl_r8, “projects . status’ AS tl_r9, “projects .
"1ft® AS tl_rl10, “projects . rgt® AS tl_rll, “projects . inherit_members® AS tl_rl2, “projects’.
“default_version_id® AS tl_rl3 FROM "versions® INNER JOIN “projects’ ON “projects’ . id =
‘versions® . project_id  WHERE (projects.status <> 9 AND projects.id IN (SELECT em.project_id FROM
enabled_modules em WHERE em.name='issue_tracking')) AND ( 1 = 1)

However, only id is needed, so , it's possible to change to

version_ids = versions_for_id(:conditions => [where]) .pluck(:1id)
def versions_for_id(options={})
Version.visible.
where (project_statement) .
where (options[:conditions]) .
includes (:project) .
references (:project)
rescue ::ActiveRecord::StatementInvalid => e
raise StatementInvalid.new (e.message)
end

As shown in diff.rb

History

#1 - 2017-08-17 09:06 - Toshi MARUYAMA
- File diff.rb.diff added

#2 - 2017-08-17 09:07 - Toshi MARUYAMA
- File deleted (diff.rb)

#3 - 2017-08-17 09:08 - Toshi MARUYAMA

- Description updated

#4 - 2017-08-17 09:11 - Toshi MARUYAMA
- Tracker changed from Defect to Patch

- Category changed from Issues to Code cleanup/refactoring

#5 - 2017-08-17 09:44 - Toshi MARUYAMA

- Status changed from New to Needs feedback

I think your IssueQuery#versions_for_id is named IssueQuery#version_ids and pluck(:id) is in it for consistency.
source:tags/3.4.2/app/models/issue_query.rb#L.310
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/3.4.2/app/models/issue_query.rb#L310

Please add ".diff" in your patch file name and remove commented lines from your patch.

#6 - 2017-08-17 23:21 - jwjw yy
- File issue_query.diff added

done

#7 - 2017-08-18 05:54 - Toshi MARUYAMA
- File issue_query.v3.diff added
- Status changed from Needs feedback to New

- Target version set to 4.1.0

pluck(:id) in IssueQuery#version_ids is missing.

#8 - 2017-08-18 19:01 - jwjw yy

- Status changed from New to Resolved

#9 - 2017-08-18 19:50 - Toshi MARUYAMA

- Status changed from Resolved to New

#10 - 2018-07-16 01:53 - jwjw yy

- Status changed from New to Resolved

Removed advertisement -- Holger Just

#11 - 2018-07-16 13:52 - Holger Just

- Status changed from Resolved to New

#12 - 2019-06-20 15:56 - Jean-Philippe Lang
- Target version changed from 4.1.0 to 4.2.0

Need some work to avoid duplicate code with IssueQuery#versions.

#13 - 2021-03-12 09:38 - Go MAEDA

- Target version changed from 4.2.0 to Candidate for next major release

#14 - 2024-01-20 09:39 - Go MAEDA
- Status changed from New to Closed

- Target version deleted (Candidate for next major release)

The map was replaced with pluck in r21499.

Files

diff.rb.diff 1.8 KB 2017-08-17 Toshi MARUYAMA
issue_query.diff 1.67 KB 2017-08-17 jwiw yy
issue_query.v3.diff 1.75 KB 2017-08-18 Toshi MARUYAMA
https://www.redmine.org/users/2784
https://www.redmine.org/projects/redmine/repository/svn/revisions/21499
